<?php

declare(strict_types=1);

namespace Seka\Portal\Modul\Terminy\Notifications\Udalost;

use Illuminate\Bus\Queueable;
use Seka\Portal\Modul\Terminy\Entities\Dtos\UdalostDTO;
use Illuminate\Notifications\Notification;
use Illuminate\Contracts\Queue\ShouldQueue;
use Seka\Portal\Modul\Terminy\Mail\Udalost\ZrusenaUdalostMail;

/**
 * Class ZrusenaUdalostNotifikaciaMail
 *
 * @package Seka\Portal\Modul\Terminy\Notifications\Udalost
 */
class ZrusenaUdalostNotifikaciaMail extends Notification implements ShouldQueue
{
    use Queueable;

    /**
     * @var \Seka\Portal\Modul\Terminy\Entities\Dtos\UdalostDTO
     */
    public UdalostDTO $udalost;

    /**
     * ZrusenaUdalostNotifikaciaMail constructor.
     *
     * @param \Seka\Portal\Modul\Terminy\Entities\Dtos\UdalostDTO $udalost
     */
    public function __construct(UdalostDTO $udalost)
    {
        $this->udalost = $udalost;
    }

    /**
     * @return string[]
     */
    public function via(): array
    {
        return [
            'mail'
        ];
    }

    /**
     * @param $notifiable
     *
     * @return \Seka\Portal\Modul\Terminy\Mail\Udalost\ZrusenaUdalostMail
     */
    public function toMail($notifiable): ZrusenaUdalostMail
    {
        return (new ZrusenaUdalostMail($this->udalost))
            ->to($notifiable);
    }
}
